<p-table
  [value]="playerPositions" 
  [loading]="loading"
  [rows]="30" 
  [showCurrentPageReport]="true"
  [scrollable]="true" scrollHeight="flex"
  dataKey="id"
  [paginator]="true"
  >
  <!-- <ng-template pTemplate="caption">
    <button pButton pRipple label="New PlayerPosition" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button>
  </ng-template> -->

  <ng-template pTemplate="caption">
    <div class="flex space-between">
      <form *ngIf="teams" class="flex" [formGroup]="formGroup">
        <span class="p-float-label">
          <p-dropdown [style]="{ width: '11rem' }" appendTo="body" formControlName="teamId" [options]="teams"
            placeholder="Select a playerFilter" inputId="float-label" optionLabel="name" [virtualScroll]="true"
            [virtualScrollItemSize]="38" [filter]="true">
          </p-dropdown>
          <label class="label-mobile" for="float-label">Team</label>
        </span>
      </form>

      <div class="buttons-container">
        <button style="max-height: 46px;" pButton pRipple label="Save changes" [disabled]="isSaveChangesDisabled" icon="pi pi-save" class="p-button-primary mr-2" (click)="saveChanges()"></button>
        <!-- <button style="max-height: 46px;" pButton pRipple label="New Player" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button> -->
      </div>
    </div>
  </ng-template>

  <ng-template pTemplate="header">
    <tr>
      <!-- <th pSortableColumn="id">Id
        <p-sortIcon field="id"></p-sortIcon>
      </th> -->
      <th pSortableColumn="name">Name
        <p-sortIcon field="name"></p-sortIcon>
      </th>
      <!-- <th pSortableColumn="playerId">PlayerId
        <p-sortIcon field="playerId"></p-sortIcon>
      </th> -->
      <!-- <th pSortableColumn="teamId">TeamId
        <p-sortIcon field="teamId"></p-sortIcon>
      </th> -->
      <th pSortableColumn="position">Position
        <p-sortIcon field="position"></p-sortIcon>
      </th>
      <th pSortableColumn="best">BP
        <p-sortIcon field="best"></p-sortIcon>
      </th>
      <th pSortableColumn="spotUp">SU
        <p-sortIcon field="spotUp"></p-sortIcon>
      </th>
      <th pSortableColumn="driver">Driver
        <p-sortIcon field="driver"></p-sortIcon>
      </th>
      <th pSortableColumn="cbs">CP
        <p-sortIcon field="cbs"></p-sortIcon>
      </th>
      <th pSortableColumn="css">CS
        <p-sortIcon field="css"></p-sortIcon>
      </th>
      <th pSortableColumn="bhd">BHD
        <p-sortIcon field="bhd"></p-sortIcon>
      </th>
      <th pSortableColumn="bhs">BHS
        <p-sortIcon field="bhs"></p-sortIcon>
      </th>
      <th pSortableColumn="wtf">MS
        <p-sortIcon field="wtf"></p-sortIcon>
      </th>
      <th pSortableColumn="sus">SUS
        <p-sortIcon field="sus"></p-sortIcon>
      </th>
      <!-- <th>Actions</th> -->
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-playerPosition let-editing="editing" let-ri="rowIndex">
    <tr>
      <td [pEditableColumn]="playerPosition.name" pEditableColumnField="name">
        <p-cellEditor>
          <ng-template pTemplate="input">
              <input pInputText type="text" [(ngModel)]="playerPosition.name" />
          </ng-template>
          <ng-template pTemplate="output">
              {{ playerPosition.name }}
          </ng-template>
      </p-cellEditor>
      </td>
      <!-- <td>{{ playerPosition.id }}</td> -->
      <!-- <td>{{ playerPosition.name }}</td> -->
      <!-- <td>{{ playerPosition.playerId }}</td> -->
      <!-- <td>{{ playerPosition.teamId }}</td> -->

    <td [pEditableColumn]="playerPosition.position" pEditableColumnField="position">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-dropdown 
              appendTo="body" 
              [(ngModel)]="playerPosition.position" [options]="positionOptions">
            </p-dropdown>
          </ng-template>
          <ng-template pTemplate="output">
              {{ playerPosition.position }}
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.best" pEditableColumnField="best">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.best" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.best" 
              [binary]="true">
            </p-checkbox>
              <!-- {{ playerPosition.best }} -->
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.spotUp" pEditableColumnField="spotUp">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.spotUp" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.spotUp" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.driver" pEditableColumnField="driver">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.driver" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.driver" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.cbs" pEditableColumnField="cbs">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.cbs" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.cbs" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.css" pEditableColumnField="css">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.css" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.css" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.bhd" pEditableColumnField="bhd">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.bhd" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.bhd" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.bhs" pEditableColumnField="bhs">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.bhs" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.bhs" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.wtf" pEditableColumnField="wtf">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.wtf" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.wtf" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>

    <td [pEditableColumn]="playerPosition.wtf" pEditableColumnField="sus">
      <p-cellEditor>
          <ng-template pTemplate="input">
            <p-checkbox [(ngModel)]="playerPosition.sus" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
          <ng-template pTemplate="output">
            <p-checkbox [(ngModel)]="playerPosition.sus" 
              [binary]="true">
            </p-checkbox>
          </ng-template>
      </p-cellEditor>
    </td>


    

      <!-- <td>{{ playerPosition.position }}</td> -->
      <!-- <td>{{ playerPosition.best }}</td> -->
      <!-- <td>{{ playerPosition.spotUp }}</td> -->
      <!-- <td>{{ playerPosition.driver }}</td> -->
      <!-- <td>{{ playerPosition.cbs }}</td> -->
      <!-- <td>{{ playerPosition.css }}</td> -->
      <!-- <td>{{ playerPosition.bhd }}</td> -->
      <!-- <td>{{ playerPosition.bhs }}</td> -->
      <!-- <td>{{ playerPosition.wtf }}</td> -->

      <!-- <td class="playerPositions-actions">
        <button pButton type="button" icon="pi pi-eye" (click)="showPlayerPosition(playerPosition)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple type="button" icon="pi pi-pencil" (click)="openEdit(playerPosition)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple icon="pi pi-trash" class="p-button-rounded p-button-danger p-button-text" (click)="deletePlayerPosition(playerPosition)"></button>
      </td> -->
    </tr>
  </ng-template>
</p-table>

<p-dialog [(visible)]="playerPositionDialog" [style]="{ width: '450px' }" [header]="actionMode + ' player position'" [modal]="true" styleClass="p-fluid">
  <ng-template pTemplate="content">
      <div class="field field-dropdown">
          <label for="player">Player</label>
          <p-dropdown optionLabel="name"  appendTo="body" 
            [(ngModel)]="newPlayerPosition.playerId" [options]="players" 
            placeholder="Select player" [showClear]="true"
            [virtualScroll]="true" [editable]="true"
            [virtualScrollItemSize]="38" [filter]="true">
          </p-dropdown>
          <small class="p-error" *ngIf="submitted && !newPlayerPosition.playerId">Player is required.</small>
      </div>

      <div class="field field-dropdown">
        <label for="team">Team</label>
        <p-dropdown optionLabel="name" [filter]="true"  appendTo="body" [(ngModel)]="newPlayerPosition.teamId" [options]="teams" placeholder="Select team"></p-dropdown>
        <!-- <input [disabled]="actionMode === ActionMode.VIEW" rows="5" cols="30" pInputTextarea [(ngModel)]="newPlayerPosition.position"> -->
        <small class="p-error" *ngIf="submitted && !newPlayerPosition.teamId">Team is required.</small>
      </div>

      <div class="field field-dropdown">
        <label for="position">Position</label>
        <p-dropdown rows="5" cols="30"  appendTo="body" [(ngModel)]="newPlayerPosition.position" [options]="positionOptions" placeholder="Select position"></p-dropdown>
        <!-- <input [disabled]="actionMode === ActionMode.VIEW" rows="5" cols="30" pInputTextarea [(ngModel)]="newPlayerPosition.position"> -->
        <small class="p-error" *ngIf="submitted && !newPlayerPosition.position">Position is required.</small>
      </div>

      <div class="flex gap">
        <div class="column gap">
          <p-checkbox [(ngModel)]="newPlayerPosition.best" [binary]="true" id="best" inputId="best" label='Bp'></p-checkbox>
          <p-checkbox [(ngModel)]="newPlayerPosition.spotUp" [binary]="true" id="spotUp" inputId="spotUp" label='SpotUp'></p-checkbox>
          <p-checkbox [(ngModel)]="newPlayerPosition.driver" [binary]="true" id="driver" inputId="driver" label='Driver'></p-checkbox>
          <p-checkbox [(ngModel)]="newPlayerPosition.cbs" [binary]="true" id="cbs" inputId="cbs" label='CP'></p-checkbox>
          
        </div>
        <div class="column gap">
          <p-checkbox [(ngModel)]="newPlayerPosition.css" [binary]="true" id="css" inputId="css" label='Sc'></p-checkbox>
          <p-checkbox [(ngModel)]="newPlayerPosition.bhd" [binary]="true" id="bhd" inputId="bhd" label='Bhd'></p-checkbox>
          <p-checkbox [(ngModel)]="newPlayerPosition.bhs" [binary]="true" id="bhs" inputId="bhs" label='Bhs'></p-checkbox>
          <p-checkbox [(ngModel)]="newPlayerPosition.wtf" [binary]="true" id="wtf" inputId="wtf" label='MS'></p-checkbox>
        </div>
      </div>

      <!-- <div class="field double-checkbox-container">
        <p-checkbox [(ngModel)]="newPlayerPosition.css" [binary]="true" id="css" inputId="css" label='Sc'></p-checkbox>
        <p-checkbox [(ngModel)]="newPlayerPosition.best" [binary]="true" id="best" inputId="best" label='Bp'></p-checkbox>
      </div>

      <div class="field double-checkbox-container">
        <p-checkbox [(ngModel)]="newPlayerPosition.bhd" [binary]="true" id="bhd" inputId="bhd" label='Bhd'></p-checkbox>
        <p-checkbox [(ngModel)]="newPlayerPosition.spotUp" [binary]="true" id="spotUp" inputId="spotUp" label='SpotUp'></p-checkbox>
      </div>

      <div class="field double-checkbox-container">
        <p-checkbox [(ngModel)]="newPlayerPosition.bhs" [binary]="true" id="bhs" inputId="bhs" label='bhs'></p-checkbox>
        <p-checkbox [(ngModel)]="newPlayerPosition.driver" [binary]="true" id="driver" inputId="driver" label='Driver'></p-checkbox>
      </div>

      <div class="field double-checkbox-container">
        <p-checkbox [(ngModel)]="newPlayerPosition.wtf" [binary]="true" id="wtf" inputId="wtf" label='MS'></p-checkbox>
        <p-checkbox [(ngModel)]="newPlayerPosition.cbs" [binary]="true" id="cbs" inputId="cbs" label='Ncs'></p-checkbox>
      </div> -->

      <!-- <div class="field">
      </div>

      <div class="field">
      </div>

      <div class="field">
      </div>

      <div class="field">
      </div> -->
      
  </ng-template>

  <ng-template pTemplate="footer">
      <button pButton pRipple label="Cancel" icon="pi pi-times" class="p-button-text" (click)="hideDialog()"></button>
      <button *ngIf="actionMode !== ActionMode.VIEW" pButton pRipple label="Save" icon="pi pi-check" class="p-button-text" (click)="savePlayerPosition()"></button>
  </ng-template>
</p-dialog>

<p-toast [breakpoints]="{'768px': {width: '90%'}}"></p-toast>
<p-confirmDialog [breakpoints]="{'768px': 'unset'}" [style]="{width: '50vw'}"></p-confirmDialog>